

import java.applet.*;
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.text.*;
import javax.sound.sampled.*;
import javax.swing.ImageIcon;

// threading, double buffering, timer, and image loading stuff based on
// tutorial and source found here:
// http://www.spacejack.org/games/dbufanim/
// by Mike Linkovich

//hiscore class
class hiScore
{
        String name = "";
        long score;
        int level;
        int bestStreak;

        public hiScore(){ }
		public hiScore(String nm, long sc, int lv, int st){ name = new String(nm); score = sc; level = lv; bestStreak = st; }
}

//2d coordinate class
class vertex2d
{
        public float x = 0.0f, y = 0.0f;

        //constructor methods
        public vertex2d(){ }
        public vertex2d(float newx, float newy){ x = newx; y = newy; }
}


//3d coordinate class
class vertex3d
{
        public float x = 0.0f, y = 0.0f, z = 0.0f;

        //constructor methods
        public vertex3d(){ }
        public vertex3d(float newx, float newy, float newz){ x = newx; y = newy; z = newz; }
}


//test class for food/bombs, etc.
class foodObject
{
        final static int MAX_FOOD_TYPES = 4;       // # of food types..
        final static int BASE_FOOD_SCORE = 100;    // base food pointage(sp?)..
        final static int FOOD_TYPE_BURGER = 0;     // just defining food types..
        final static int FOOD_TYPE_HOTDOG = 1;     // just defining food types..
        final static int FOOD_TYPE_BOMB = 2;       // just defining food types..
        final static float SWALLOW_SPEED = 4.0f;   // speed food goes down fb's throat

        public float radius = 10.0f;               // radius in pixels..
        public vertex2d pos = new vertex2d();      // position vertex
        public vertex2d vel = new vertex2d();      // velocity vertex
        public int x_old = 0, y_old = 0;
        public int type = 0;                       // type of food (hot dog, bomb, etc.)
        public int active = 0;                     // active or dead?
        public int points = 500;                   // points when eaten

        //activation method
        public void activate(){
                type = (int)((float)Math.random()*3.0);
                points = (type != FOOD_TYPE_BOMB ? BASE_FOOD_SCORE*(type+1) : -BASE_FOOD_SCORE*5);  // if bomb, subtract points
                pos.x = (float)Math.random()*(fbJava.FAPP_W-30.0f)+10.0f;
                pos.y = -20.0f;
                vel.x = 0.0f;
                vel.y = (float)Math.random()*2.0f+1.0f;
                active = 1;
                }

        //activation method
        public void activate(int level){
                type = (int)((float)Math.random()*3.0);
                points = (type != FOOD_TYPE_BOMB ? BASE_FOOD_SCORE*(type+1) : -BASE_FOOD_SCORE*5);  // if bomb, subtract points
                pos.x = (float)Math.random()*fbJava.FAPP_W-20.0f;
                pos.y = -20.0f;
                vel.x = 0.0f;
                vel.y = (float)Math.random()*1.5f+1.0f+(float)level*0.035f;
                active = 1;
                }

        //deactivation method
        public void die(){
                active = 0;
                }

        //method for starting going down throat
        public void swallow(){
                vel.y = SWALLOW_SPEED;
                active = 2;
                }

        //method for finishing the swallow
        public void digested(){
                active = 0;
                }

        //constructor method
        public foodObject(){ }
}


//food boy class
class foodBoy
{
        final static int NUM_FB_MODES = 4;
        final static int MAX_FB_MODE_ANIMS = 6;
        final static float MOUTH_X1 = 16.0f;  //start x for mouth detection rect
        final static float MOUTH_X2 = 42.0f;  //end x for mouth detection rect
        final static int INJURY_LENGTH = 75;

        vertex2d pos = new vertex2d();   // position vertex
        vertex2d old_pos = new vertex2d(); // last position vertex
        vertex2d vel = new vertex2d();   // velocity vertex
        float radius = 36.0f;            // radius
        int active = 0;                  // active level
        int credits = 3;                 // # lives/credits
        int animCounter = 0;             // animation counter
        long score = 0;                  // total score
        int curLevel = 0;                // current game level
        int numMissed = 0;               // keep track of food that hit the ground
        int curStreak = 0;               // current food streak (# food eaten in a row without missing or hitting a bomb)
        int bestStreak = 0;              // current record food streak
        Image pic[][] = new Image[NUM_FB_MODES][MAX_FB_MODE_ANIMS];   // images
        public boolean animActive = false;  // toggle animation
        public boolean animReverse = false; // toggle animation reverse counter

        //constructor methods
        public foodBoy(){ }
        public foodBoy(vertex2d coords, int creds, int level){ pos = coords; credits = creds; curLevel = level; }

        //initial activation method
        public void preActivate(){
                score = 0;                          //start score at zero
                animCounter = 0;                    //reset animation counter
                animReverse = animActive = false;   //deactivate animation vars
                curLevel = 0;                       //start at level 0
                active = 1;                         //ready to eat
                credits = 3;                        //reset credit total
                pos.x = (160.0f-2.0f*radius)+radius; //start at middle of the window
                //pos.y = fbJava.FAPP_H-2.0f*radius-fbJava.APP_WINDOWBAR_HEIGHT; //start a bit above the bottom of the window
                pos.y = fbJava.FAPP_H-2.0f*radius; //start a bit above the bottom of the window
                old_pos = pos;                         //blah
                }

        //fb dies..
        public void die(){
                active = 0;      //deactivate
                animCounter = 0; //reset animation counter
                credits--;       //take a credit off
                }

        //fb lives again..
        public void live(){
                active = 1;      //ready to eat again
                animCounter = 0; //reset animation counter
                }

        //fb is injured..
        public void injure(){
                active = 2;       //set to injured state
                animCounter = 0;  //reset animation counter
                credits--;        //take a life off
                if(credits < 0){     //all credits used up, time to go..
                        credits = 0; //set credits back to zero for display
                        active = 3;  //set to 'game over' state
                        }
                curStreak = 0;    //end current streak
                }
}


//font class
class blahFont
{
        final static int DEFAULT_WIDTH = 10;
        final static int DEFAULT_HEIGHT = 12;

        int width = DEFAULT_WIDTH, height = DEFAULT_HEIGHT;
        Image pic[] = new Image[256];   // images of characters

        //methods to show width and height
        int getWidth(){ return width; }
        int getHeight(){ return height; }

        //constructor method
        public blahFont(){ }

}

//courtesy of http://www.spacejack.org/games/dbufanim/
//  This class will take the current time, and return
//  an "averaged" time-slice back.  It gives us better
//  results than simply using Java's timer at face value.
//
class AverageTimer
{
        final static int  NUM_SAMPLES = 6;      //  # of samples to use for an average
        final static long INIT_MSPF = 30;       //  Initial assumed millis per frame (30ms is approx. 30fps)
        final static long MAX_DT = 100;         //  Max time for 1 frame.  This weeds out "spikes"
                                          //  that would advance the sim too much for 1 frame
        long  m_tick[] = new long[NUM_SAMPLES]; //  Array to remember samples
        int   m_index = 0;                      //  Current index to "circular" array

        public AverageTimer( long t )
        {
                int  i;

                //  Fill array with an assumed rate so far.. (INIT_MSPF)
                //  The actual times will quickly fix this, after NUM_SAMPLES samples.
                //
                for( i = NUM_SAMPLES - 1; i >= 0; i-- )
                m_tick[i] = t - ((NUM_SAMPLES - i) * INIT_MSPF);

                m_index = 0;
        }

        //  By supplying the current time (by using System.currentTimeMillis())
        //  we calculate the average time over the past NUM_SAMPLES frames, and record
        //  this current time to continue keeping the average accurate as possible.
        //
        public long deltaT( long cur_t )
        {
                int id = m_index-1;                       //  Calc index to previous sample
                if( id < 0 )                              //  Wrap if necessary..
                   id += NUM_SAMPLES;

                long dt = cur_t - m_tick[id];             //  Dif time since prev sample

                if( dt > MAX_DT )                         //  If the slice was too big,
                {                                         //  we have to advance all the previous
                        long ct = dt - MAX_DT;                  //  times by the diff..
                        for( int i = 0; i < NUM_SAMPLES; i++ )
                        m_tick[i] += ct;
                }

                long t = cur_t - m_tick[m_index];         //  Time dif since oldest time recorded
                m_tick[m_index] = cur_t;                  //  Save the current one now
                m_index = (m_index + 1) % NUM_SAMPLES;    //  Advance the index

                dt = t / (long)NUM_SAMPLES;               //  Calculate the final average time

                return dt;
        }
}


// main applet
//
public class fbJava extends Applet implements Runnable, KeyListener, MouseListener, MouseMotionListener
{
        final static int GAMESTATE_TITLE = 1;       //title screen
        final static int GAMESTATE_START = 5;       //start state
        final static int GAMESTATE_GAME_OVER = 10;  //game over state

        final static int MAX_HISCORES = 20;         //max hiscores to track
        final static int MAX_NAME_LENGTH = 24;         //max hiscores to track

        final static int  MAX_FOOD_SLOTS = 32;      //# of food slots..
        final static int FONT_WIDTH = 8;

        final static int    APP_W = 320,            //applet dimensions
                                    APP_H = 240;

        final static float  FAPP_W = (float)APP_W,
                                    FAPP_H = (float)APP_H;

		final static int APP_WINDOWBAR_HEIGHT = 40;
		//final static int APP_WINDOWBAR_HEIGHT = 0;
		
		final static int CREDITS_OFFSET = 25;


		final static String VERSION_STRING = "Food Boy Java v0.9a";
		final static String HISCORE_FILENAME = "fbJava.hi";

        Thread    m_thrApp = null;                  //Main applet thread

        Image     img_scBuff = null;                //Image for off-screen drawing -- "back buffer"
        Graphics  g_scBuff = null;                  //Graphics drawing interface to offscr image
        Color     m_clrBg = new Color(60, 0, 60);   //Background colour

        BufferedImage     bg_image = null;        //test bg image..
        BufferedImage     food_image[] = new BufferedImage[foodObject.MAX_FOOD_TYPES];  //food image array
        BufferedImage     cred_image = null;      //image for credits display
        BufferedImage     cloud_image[] = new BufferedImage[2];  //images for bg clouds
        BufferedImage     logo_image = null;      //image for fb logo

        blahFont gameFont = new blahFont();  //fbjava font

        foodObject food = new foodObject();  //food objects

        foodBoy FB = new foodBoy();          //food boy

        AverageTimer  m_avgTimer = null;

        int curLevel = 0;                    //current level
        int gameState = GAMESTATE_TITLE;     //set game state
        int scoreTimer = 0;                  //just some timers for having text scale slightly..
        int levelTimer = 0;
        int streakTimer = 0;
        int bestTimer = 0;

		boolean isOnline = false;
		boolean isApplication = true;
		boolean soundOn = true;
		boolean useFullscreen = false;

        vertex2d gameOver_pos = new vertex2d(0.0f, 0.0f);  //"game over" position
        vertex2d gameOver_vel = new vertex2d(0.0f, 0.0f);  //"game over" velocity

        vertex2d cloud0_pos = new vertex2d(-150.0f, (float)Math.random()*70.0f); //big cloud position
        vertex2d cloud0_vel = new vertex2d((float)Math.random()*1.15f+0.15f, 0.0f); //big cloud velocity
        vertex2d cloud1_pos = new vertex2d(-150.0f, (float)Math.random()*70.0f); //little cloud position
        vertex2d cloud1_vel = new vertex2d((float)Math.random()*1.0f+0.15f, 0.0f); //little cloud velocity

        Clip chomp_sound;   //chomping sound
        Clip bomb_sound;    //explosion sound
        Clip levelup_sound; //level up chime

        String hiScoreName = ""; //highest score name
        long hiScoreScore = 0;   //highest score
        boolean gotHiScore = false;  //tells if a high score was obtained
        boolean doneTypingName = false;  //tells if we're done typing the name

        remoteWrite remoteWriter = new remoteWrite();

        hiScore[] gameHiScore = new hiScore[MAX_HISCORES];
        int numScores = MAX_HISCORES;
        int cursorPos = 0;   //cursor position when typing name..
        int scoreStart = 0, scoreEnd = 10;   //set the starting and ending scores for display
        //vertex2d scoreBoardPos = new vertex2d(FAPP_W, FAPP_H-40.0f);
        vertex2d scoreBoardPos = new vertex2d(FAPP_W, FAPP_H-2);
        int scoreBoardWidth = 0;

        String playerName = "";   //current player name

        // applet initialization
        //
        public void init()
        {
                setBackground(m_clrBg);         //  Set the background color
                resize(APP_W, APP_H);    //  Set applet size

                //  Create an off-screen drawing buffer
                //  for double-buffered graphics...
                //
                try
                {
                        img_scBuff = createImage(APP_W, APP_H);
                        g_scBuff = img_scBuff.getGraphics();
                }
                catch (Exception e)
                {
                        System.out.println("Failed to set up double-buffered graphics");
                        img_scBuff = null;
                        g_scBuff = null;
                        return;
                }

                g_scBuff.setColor( m_clrBg );
                g_scBuff.fillRect(0, 0, APP_W, APP_H);

                //add listeners
                //addWindowListener(this);
                addMouseListener(this);
                addMouseMotionListener(this);
                addKeyListener(this);

                //load saved hiscores
                if(isOnline) loadRemoteScores();
				else loadScores(HISCORE_FILENAME);
        }

        public void start()
        {
                if( m_thrApp == null )
                {
                        m_thrApp = new Thread(this);
                        m_thrApp.start();             //  This invokes run() (see below)
                }
        }

        public void stop()
        {
                //  Kill the thread
                m_thrApp = null;
        }


        // draw stuff to the screen
        //
        public void paint(Graphics g)
        {
                if( img_scBuff != null )
                        g.drawImage(img_scBuff, 0, 0, this);   //  Just display the "back" buffer
        }

        // update the graphics context
        //
        public void update(Graphics g)
        {
                paint(g);
        }


        //
        //  The main applet thread method -- kinda like C's main()
        //  This function will start after init() and start() have
        //  been called by the Java VM.
        //
        //  Note that once run() exits, the program will stop.
        //
        public void run()
        {
                System.out.println("applet starting...");

                if( g_scBuff == null )   //  Check that our double-buffer was created..
                        return;                 //  If not, returning will finish thread's execution

                Graphics g = getGraphics();

                //register font
                g.setFont(new Font("Dialog", Font.BOLD, 12));
                g_scBuff.setFont(new Font("Dialog", Font.BOLD, 12));

                if( !initApp(g) )          //  If inits fail, abort & exit
                        return;

                System.out.println("entering main loop...");

                while( m_thrApp != null ) //  Keep looping until thread is killed (see stop() )
                {
                        updateApp();            //  Do all logic updates
                        paintApp(g);            //  Do all graphics, display on screen

                        try                     //  Give back some CPU, otherwise
                        {                       //  we'll get very erratic perf. with some VMs
                                Thread.sleep(10);     //  10ms seems to be the sweet spot (?)
                        } catch(InterruptedException e) { stop(); }
                }

                System.out.println("applet cleanly exited.");
        }


        //mouse clicking stuff..
        //
        public void mousePressed(MouseEvent e){ }
        public void mouseClicked(MouseEvent e){
                //mouse press causes game to restart when game is over
                if(gameState == GAMESTATE_GAME_OVER){
                        FB.preActivate();
                        food.die();
                        resetScoreBoardStuff();
                        gameState = GAMESTATE_START;
                        }
                else if(gameState == GAMESTATE_TITLE){
                        FB.preActivate();
                        food.die();
                        resetScoreBoardStuff();
                        gameState = GAMESTATE_START;
                        }
                }
        public void mouseEntered(MouseEvent e){ }
        public void mouseExited(MouseEvent e){
                if(FB.pos.x < FB.old_pos.x){  // mouse exits left side of screen
                        FB.pos.x = 0.0f;
                        }
                }
        public void mouseReleased(MouseEvent e){ }


        //mouse motion stuff..
        //
        public void mouseDragged(MouseEvent e){ }
        public void mouseMoved(MouseEvent e){
                if(gameState == GAMESTATE_START){ //only follow the mouse when game isn't over yet
                        FB.old_pos = FB.pos;      //store old coords
                        FB.pos.x = (float)e.getX()-FB.radius;   //cling fb to mouse x coord
                        }
                }


        //  Handle Mouse button presses
        //
        public boolean mouseDown( Event evt, int x, int y )
        {
                return true;
        }


        //keyboard input stuff..
        //
        public void keyPressed(KeyEvent e){
                if(e.getKeyCode() == KeyEvent.VK_BACK_SPACE){
                        int len = playerName.length();
                        String str = playerName.substring(0, len-1);
                        playerName = str;
                        }
                else if(e.getKeyCode() == KeyEvent.VK_ENTER){
                        doneTypingName = true;
                        System.out.println("Name entry finished.");
                        }
                }

        public void keyReleased(KeyEvent e){
                }

        public void keyTyped(KeyEvent e){
                if(!gotHiScore || doneTypingName) return;   //exit if we don't have anything to read

                if(e.getKeyCode() == KeyEvent.VK_BACK_SPACE) return;
                if(e.getKeyChar() < '0' && e.getKeyChar() != ' ') return;
                if(e.getKeyChar() > '9' && e.getKeyChar() < 'A') return;
                if(e.getKeyChar() > 'Z' && e.getKeyChar() < 'a') return;
                if(e.getKeyChar() > 'z') return;


                playerName = new String(playerName + e.getKeyChar());
                //playerName.concat(Character.toString(e.getKeyChar()));
                System.out.println("Player name: " + playerName + e.getKeyChar());
                }

		//convert the stack trace from an exception to a string so we can print it
		String exceptionStackTraceToString(Exception e)
		{
			StringWriter sw = new StringWriter();
			PrintWriter pw = new PrintWriter(sw);
			e.printStackTrace(pw);
			String str = sw.toString(); // stack trace as a string

			return str;
		}

		//play any old audio clip
		public void playClip(Clip clip)
		{
			if(clip == null) return;
			clip.setFramePosition(0);               //reset to frame 0
			clip.loop(0);
		}

		//load a clip from a file
		Clip loadAudioClipFile(String filename)
		{
				if(!soundOn) return null;

				File file = null;
				URL url = null;
				AudioInputStream ais = null;
				Clip clip = null;
				AudioFileFormat aff = null;
				AudioFormat af = null;

				URL soundURL = null;
				try
				{
					soundURL = getClass().getClassLoader().getResource(filename);
					if(soundURL == null){ System.out.println("SoundURL is null. Aborting."); return null; }
					Line.Info linfo = new Line.Info(Clip.class);
					if(linfo == null){ System.out.println("Linfo is null. Aborting."); return null; }
				    Line line = AudioSystem.getLine(linfo);
					if(line == null){ System.out.println("Line is null. Aborting."); return null; }
				    clip = (Clip)line;
					if(clip == null){ System.out.println("Clip is null. Aborting."); return null; }
				    ais = AudioSystem.getAudioInputStream(soundURL);
					if(ais == null){ System.out.println("AIS is null. Aborting."); return null; }
				    clip.open(ais);
				}
				catch(Exception e)
				{
					String str = null;
					str = exceptionStackTraceToString(e);
					//g_scBuff.setColor(Color.BLACK);
					//g_scBuff.drawString(str, errorOutputX, errorOutputY);
	       		}

				if(clip != null)
				{
					System.out.println("Clip has frame length of " + clip.getFrameLength());
					//clip.setLoopPoints(0, clip.getFrameLength());
				}

				return clip;
		}

        //use this to load a buffered image
        //by first loading an Image,
        //then converting it to a BufferedImage
        BufferedImage loadBufferedImage(String filename)
        {
                Image tempImage = loadImageSync(filename);
                return toBufferedImage(tempImage);
        }

        //create a fresh buffered image
        public static BufferedImage createBufferedImage(int w, int h)
        {
                return new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
        }

        // This method returns a buffered image with the contents of an image
        public static BufferedImage toBufferedImage(Image image)
        {
                if(image instanceof BufferedImage) {
                        return (BufferedImage)image;
                        }

                // This code ensures that all the pixels in the image are loaded
                image = new ImageIcon(image).getImage();

                // Determine if the image has transparent pixels; for this method's
                // implementation, see e661 Determining If an Image Has Transparent Pixels
                boolean hasAlpha = true;

                // Create a buffered image with a format that's compatible with the screen
                BufferedImage bimage = null;
                GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
                try {
                        // Determine the type of transparency of the new buffered image
                        int transparency = Transparency.OPAQUE;
                        if (hasAlpha) {
                                transparency = Transparency.TRANSLUCENT;
                                }
                        // Create the buffered image
                        GraphicsDevice gs = ge.getDefaultScreenDevice();
                        GraphicsConfiguration gc = gs.getDefaultConfiguration();
                        bimage = gc.createCompatibleImage(
                                image.getWidth(null), image.getHeight(null), transparency);
                        } catch (HeadlessException e) { }
                        // The system does not have a screen

                if (bimage == null) {
                        // Create a buffered image using the default color model
                        int type = BufferedImage.TYPE_INT_RGB;
                        if (hasAlpha) {
                                type = BufferedImage.TYPE_INT_ARGB;
                                }
                        bimage = new BufferedImage(image.getWidth(null), image.getHeight(null), type);
                        }

                // Copy image to buffered image
                Graphics g = bimage.createGraphics();

                // Paint the image onto the buffered image
                g.drawImage(image, 0, 0, null);
                g.dispose();

                return bimage;
        }
	



		//  loadImageSync() from http://www.spacejack.org/games/dbufanim/
        //  credits to Mike Linkovich
        //
        //  Simple method to load & wait for image synchronously
        //  rather than deal with threading.  I find this is
        //  usually more useful, however if you needed to perform
        //  other tasks while loading, then you should take advantage
        //  of Java's asynchronous getImage loads.
        //
		Image loadImageSync(String imgFile)
        {

			MediaTracker mt = null;
			Image img = null;

			//  Start loading the graphics...
			//
			if(!isApplication)
			{
				System.out.println("We're online...");
				img = getImage(getCodeBase(), imgFile);
			}
			else
			{
				URL imgURL = getClass().getResource(imgFile);
				Toolkit tk = Toolkit.getDefaultToolkit();
				System.out.println("We're in the application...");
				img = tk.getImage(imgURL);
				//img = Toolkit.getDefaultToolkit().getImage(imgFile);
				//try{ img = getImage(new File(imgFile).toURI().toURL()); } catch(Exception E){}
			}

			if(img == null) System.out.println("Image is null..");

			System.out.println("Loaded file '" + imgFile + "' with dimensions " + img.getWidth(this) + "x");

			mt = new MediaTracker(this);
			mt.addImage( img, 0 );

			//  Wait here 'till it's done
			//
			try
			{
	  			mt.waitForAll();
			}
			catch(Exception e)
			{
				img = null;
			};

			if(img == null || img.getWidth(this) < 0) System.err.println( "Failed to load image: '" + imgFile + "'" );

			return img;
		}


        //
        //  run() will call this.  So this occurs *after* init().
        //  By doing this, we could display a loader bar while
        //  resources are loaded, and we can abort if problems occur.
        //
        boolean initApp(Graphics g)
        {
                int numResources = 87, count = 0;
                int x = 20, y = 40, w = APP_W-40, h = 20;

                //draw a progress bar..
                g.setColor(Color.white);
                g.drawString("Loading game resources..", 20, 20);
                g.drawRect(x, y, w, h);
                //load images..
                bg_image = loadBufferedImage("bg.gif"); count++;

                //cloud images
                cloud_image[0] = loadBufferedImage("cloud00.gif"); count++;
                cloud_image[1] = loadBufferedImage("cloud01.gif"); count++;
                g.fillRect(x, y, w*(count/numResources), h);

                //food images
                food_image[0] = loadBufferedImage("food00.gif"); count++;  //burger pic..
                food_image[1] = loadBufferedImage("food01.gif"); count++;  //hot dog pic..
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                food_image[2] = loadBufferedImage("food02.gif"); count++;  //bomb pic (frame 1)..
                food_image[3] = loadBufferedImage("food02a.gif"); count++; //bomb pic (frame 2)..
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);

                //initialize food boy
                FB.preActivate();
                FB.pic[0][0] = loadBufferedImage("fb0000.gif");  count++; //base fb image
                FB.pic[1][0] = loadBufferedImage("fb0100.gif");  count++; //fb chomp animation
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                FB.pic[1][1] = loadBufferedImage("fb0101.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);
                FB.pic[1][2] = loadBufferedImage("fb0102.gif");  count++;
                FB.pic[1][3] = loadBufferedImage("fb0103.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                FB.pic[1][4] = loadBufferedImage("fb0104.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);
                FB.pic[1][5] = loadBufferedImage("fb0105.gif");  count++;
                FB.pic[2][0] = loadBufferedImage("fb0200.gif");  count++; //fb injured animation
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                FB.pic[3][0] = loadBufferedImage("fb0300.gif");  count++; //fb game over animation
                FB.pic[3][1] = loadBufferedImage("fb0301.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);

                //load the font..
                gameFont.pic[(int)('0')] = loadBufferedImage("font_0.gif");  count++;
                gameFont.pic[(int)('1')] = loadBufferedImage("font_1.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                gameFont.pic[(int)('2')] = loadBufferedImage("font_2.gif");  count++;
                gameFont.pic[(int)('3')] = loadBufferedImage("font_3.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);
                gameFont.pic[(int)('4')] = loadBufferedImage("font_4.gif");  count++;
                gameFont.pic[(int)('5')] = loadBufferedImage("font_5.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                gameFont.pic[(int)('6')] = loadBufferedImage("font_6.gif");  count++;
                gameFont.pic[(int)('7')] = loadBufferedImage("font_7.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);
                gameFont.pic[(int)('8')] = loadBufferedImage("font_8.gif");  count++;
                gameFont.pic[(int)('9')] = loadBufferedImage("font_9.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                gameFont.pic[(int)('A')] = loadBufferedImage("font_a.gif");  count++;
                gameFont.pic[(int)('B')] = loadBufferedImage("font_b.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);
                gameFont.pic[(int)('C')] = loadBufferedImage("font_c.gif");  count++;
                gameFont.pic[(int)('D')] = loadBufferedImage("font_d.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                gameFont.pic[(int)('E')] = loadBufferedImage("font_e.gif");  count++;
                gameFont.pic[(int)('F')] = loadBufferedImage("font_f.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);
                gameFont.pic[(int)('G')] = loadBufferedImage("font_g.gif");  count++;
                gameFont.pic[(int)('H')] = loadBufferedImage("font_h.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                gameFont.pic[(int)('I')] = loadBufferedImage("font_i.gif");  count++;
                gameFont.pic[(int)('J')] = loadBufferedImage("font_j.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);
                gameFont.pic[(int)('K')] = loadBufferedImage("font_k.gif");  count++;
                gameFont.pic[(int)('L')] = loadBufferedImage("font_l.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                gameFont.pic[(int)('M')] = loadBufferedImage("font_m.gif");  count++;
                gameFont.pic[(int)('N')] = loadBufferedImage("font_n.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);
                gameFont.pic[(int)('O')] = loadBufferedImage("font_o.gif");  count++;
                gameFont.pic[(int)('P')] = loadBufferedImage("font_p.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                gameFont.pic[(int)('Q')] = loadBufferedImage("font_q.gif");  count++;
                gameFont.pic[(int)('R')] = loadBufferedImage("font_r.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);
                gameFont.pic[(int)('S')] = loadBufferedImage("font_s.gif");  count++;
                gameFont.pic[(int)('T')] = loadBufferedImage("font_t.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                gameFont.pic[(int)('U')] = loadBufferedImage("font_u.gif");  count++;
                gameFont.pic[(int)('V')] = loadBufferedImage("font_v.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);
                gameFont.pic[(int)('W')] = loadBufferedImage("font_w.gif");  count++;
                gameFont.pic[(int)('X')] = loadBufferedImage("font_x.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                gameFont.pic[(int)('Y')] = loadBufferedImage("font_y.gif");  count++;
                gameFont.pic[(int)('Z')] = loadBufferedImage("font_z.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);
                gameFont.pic[(int)(':')] = loadBufferedImage("font_co.gif"); count++;
                gameFont.pic[(int)(' ')] = loadBufferedImage("font__.gif");  count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                gameFont.pic[(int)('a')] = gameFont.pic[(int)('A')];     count++;
                gameFont.pic[(int)('b')] = gameFont.pic[(int)('B')];     count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);
                gameFont.pic[(int)('c')] = gameFont.pic[(int)('C')];     count++;
                gameFont.pic[(int)('d')] = gameFont.pic[(int)('D')];     count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                gameFont.pic[(int)('e')] = gameFont.pic[(int)('E')];     count++;
                gameFont.pic[(int)('f')] = gameFont.pic[(int)('F')];     count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);
                gameFont.pic[(int)('g')] = gameFont.pic[(int)('G')];     count++;
                gameFont.pic[(int)('h')] = gameFont.pic[(int)('H')];     count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                gameFont.pic[(int)('i')] = gameFont.pic[(int)('I')];     count++;
                gameFont.pic[(int)('j')] = gameFont.pic[(int)('J')];     count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);
                gameFont.pic[(int)('k')] = gameFont.pic[(int)('K')];     count++;
                gameFont.pic[(int)('l')] = gameFont.pic[(int)('L')];     count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                gameFont.pic[(int)('m')] = gameFont.pic[(int)('M')];     count++;
                gameFont.pic[(int)('n')] = gameFont.pic[(int)('N')];     count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);
                gameFont.pic[(int)('o')] = gameFont.pic[(int)('O')];     count++;
                gameFont.pic[(int)('p')] = gameFont.pic[(int)('P')];     count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                gameFont.pic[(int)('q')] = gameFont.pic[(int)('Q')];     count++;
                gameFont.pic[(int)('r')] = gameFont.pic[(int)('R')];     count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);
                gameFont.pic[(int)('s')] = gameFont.pic[(int)('S')];     count++;
                gameFont.pic[(int)('t')] = gameFont.pic[(int)('T')];     count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                gameFont.pic[(int)('u')] = gameFont.pic[(int)('U')];     count++;
                gameFont.pic[(int)('v')] = gameFont.pic[(int)('V')];     count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);
                gameFont.pic[(int)('w')] = gameFont.pic[(int)('W')];     count++;
                gameFont.pic[(int)('x')] = gameFont.pic[(int)('X')];     count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                gameFont.pic[(int)('y')] = gameFont.pic[(int)('Y')];     count++;
                gameFont.pic[(int)('z')] = gameFont.pic[(int)('Z')];     count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);

                //load credits image..
                cred_image = loadBufferedImage("fbcreds.gif"); count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);

                //load logo image..
                logo_image = loadBufferedImage("fblogo.gif"); count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);

                //load sound effects
                //chomp_sound = getAudioClip(getDocumentBase(), "sfx_chom.wav"); count++;
				chomp_sound = loadAudioClipFile("sfx_chom.wav"); count++;
                //bomb_sound = getAudioClip(getDocumentBase(), "sfx_expl.wav"); count++;
                bomb_sound = loadAudioClipFile("sfx_expl.wav"); count++;
                g.fillRect(x, y, (int)(w*((float)count/numResources)), h);
                //levelup_sound = getAudioClip(getDocumentBase(), "sfx_lvup.wav"); count++;
                levelup_sound = loadAudioClipFile("sfx_lvup.wav"); count++;
                g.fillRect(x, y, (int)(w*((float)(count)/numResources)), h);

                //  Start our average timer now..
                //
                m_avgTimer = new AverageTimer( System.currentTimeMillis() );

                return true;
        }


        //
        //  paintApp and updateApp are the guts of our program.
        //  run() calls these each frame in its main loop.
        //
        //
        void paintApp(Graphics g)
        {
                // draw bg image..
                g_scBuff.drawImage(bg_image, 0, 0, this);

                // draw clouds..
                g_scBuff.drawImage(cloud_image[1], (int)cloud1_pos.x, (int)cloud1_pos.y, this);
                g_scBuff.drawImage(cloud_image[0], (int)cloud0_pos.x, (int)cloud0_pos.y, this);

                // draw current food object..
                //
                if(gameState == GAMESTATE_START){   //only draw food if game isn't over yet
                        g_scBuff.drawImage(food_image[food.type != food.FOOD_TYPE_BOMB ? food.type : food.type+(int)(Math.random()*2.0f)], (int)food.pos.x, (int)food.pos.y, this);   //draw single frame for all food objects except bomb (random frame change to sprinkler anim)
                        }

                // draw food boy..
                //
                g_scBuff.drawImage(FB.pic[FB.active][FB.active != 2 ? FB.animCounter : 0], (int)FB.pos.x, (int)FB.pos.y, this);   //draw animation frames only if in chomp animation

                // draw score, credits, etc. (except at title screen)
                //
                if(gameState != GAMESTATE_TITLE){
                        String score_str = new String();   // score string
                        String stat_str = new String();    // credits, etc. string
                        String level_str = new String();   // level count string
                        String streak_str = new String();  // food streak string
                        String best_str = new String();    // record streak string

                        //score_str += "Score: "; score_str += Long.toString(FB.score);
                        score_str += "Score:"; score_str += longNumberString(FB.score, 7);
                        stat_str += Integer.toString(FB.credits);
                        level_str += "Level:"; level_str += Integer.toString(curLevel+1);
                        streak_str += "Streak:"; streak_str += Integer.toString(FB.curStreak);
                        best_str += "Best:"; best_str += Integer.toString(FB.bestStreak);

                        //g_scBuff.drawString(score_str, 20, 15);
                        //g_scBuff.drawString(stat_str, 130, 15);
                        //g_scBuff.drawString(level_str, 260, 15);
                        //g_scBuff.drawString(streak_str, 20, 28);

                        //draw strings using custom font..
                        //draw score tally
                        for(int i = 0; i < score_str.length(); i++){
                                g_scBuff.drawImage(gameFont.pic[(int)score_str.charAt(i)], 5+i*gameFont.width, 5, gameFont.width+(i <= 5 ? 0 : scoreTimer), gameFont.height+(i <= 5 ? 0 : scoreTimer), this);
                                }

                        //draw fb credits image and show # of credits left
                        //g_scBuff.drawImage(cred_image, fbJava.APP_W-40, fbJava.APP_H-30, this);
                        g_scBuff.drawImage(cred_image, fbJava.APP_W-40, fbJava.APP_H-CREDITS_OFFSET, this);
                        for(int i = 0; i < stat_str.length(); i++){
                                g_scBuff.drawImage(gameFont.pic[(int)stat_str.charAt(i)], fbJava.APP_W-24+i*gameFont.width, fbJava.APP_H-CREDITS_OFFSET+4, this);
                                }

                        //draw level status message, draw the trailing #'s with scaling for effect..
                        for(int i = 0; i < level_str.length(); i++){
                                g_scBuff.drawImage(gameFont.pic[(int)level_str.charAt(i)], 210+i*gameFont.width, 5, gameFont.width+(i <= 5 ? 0 : levelTimer), gameFont.height+(i <= 5 ? 0 : levelTimer), this);
                                }

                        for(int i = 0; i < streak_str.length(); i++){
                                g_scBuff.drawImage(gameFont.pic[(int)streak_str.charAt(i)], 5+i*gameFont.width, 21, gameFont.width+streakTimer, gameFont.height+streakTimer, this);
                                }

                        for(int i = 0; i < best_str.length(); i++){
                                g_scBuff.drawImage(gameFont.pic[(int)best_str.charAt(i)], 131+i*gameFont.width, 21, gameFont.width+bestTimer, gameFont.height+bestTimer, this);
                                }
                        }
                else{
                        //if at title screen, draw the logo and tell how to start..
                        g_scBuff.drawImage(logo_image, fbJava.APP_W/2-70, 40, this);
                        g_scBuff.setFont(new Font("Dialog", Font.BOLD, 14));  //go back to normal size
                        g_scBuff.setColor(m_clrBg);
                        g_scBuff.drawString("[ Click anywhere to play ]", fbJava.APP_W/2-(13*14)/2, fbJava.APP_H/2);
                        //hiScoreDisplay(g_scBuff, 0, APP_H-57, APP_W, 20);
                        hiScoreDisplay(g_scBuff, 0, APP_H-15, APP_W, 15);
                        }

                // draw "game over", etc.
                //
                if(gameState == GAMESTATE_GAME_OVER){
                        g_scBuff.setFont(new Font("Dialog", Font.BOLD, 14));  //go back to normal size
                        g_scBuff.setColor(m_clrBg);
                        g_scBuff.drawString("[ Click anywhere to play again ]", fbJava.APP_W/2-(16*14)/2, fbJava.APP_H-100);
                        g_scBuff.setFont(new Font("Dialog", Font.BOLD, 24));  //make font larger for game over message
                        g_scBuff.setColor(new Color(255, 20, 20));
                        g_scBuff.drawString("Game Over", (int)gameOver_pos.x, (int)gameOver_pos.y);
                        g_scBuff.setFont(new Font("Dialog", Font.BOLD, 12));  //go back to normal size
                        g_scBuff.setColor(m_clrBg);
                        if(gotHiScore && !doneTypingName){
                                hiScoreEntryDisplay(g_scBuff);
                                }
                        else{
                                //hiScoreDisplay(g_scBuff, 0, APP_H-30, APP_W, 28);
                                hiScoreDisplay(g_scBuff, 0, APP_H-15, APP_W, 15);
                                }
                        }

                //  Now that the back buffer has been fully re-drawn,
                //  display it on the "front" buffer
                //
                g.drawImage(img_scBuff, 0, 0, this);
        }


        void updateApp()
        {
                //  Get the elapsed (and averaged) time slice
                //
                long  dt = m_avgTimer.deltaT( System.currentTimeMillis() );

                //  Convert to a float fraction of 1 sec
                //
                float ft = (float)dt * 0.001f;

                //move the bg clouds..
                cloud0_pos.x += cloud0_vel.x;
                cloud1_pos.x += cloud1_vel.x;
                if(cloud0_pos.x > fbJava.FAPP_W+150.0f){
                        cloud0_pos.x = -150.0f;
                        cloud0_pos.y = (float)Math.random()*70.0f;
                        cloud0_vel.x =(float)Math.random()*1.15f+0.15f;
                        }
                if(cloud1_pos.x > fbJava.FAPP_W+150.0f){
                        cloud1_pos.x = -150.0f;
                        cloud1_pos.y = (float)Math.random()*70.0f;
                        cloud1_vel.x = (float)Math.random()*1.0f+0.15f;
                        }

                //do the food update stuff..
                //
                if(gameState != GAMESTATE_GAME_OVER){
                        food.pos.x += food.vel.x;      //only drop food when game is not over
                        food.pos.y += food.vel.y;
                        }
                else{
                        food.active = 3;               //if game over, food set to inactive state
                        }

                if(food.active == 0 && gameState != GAMESTATE_TITLE){ //food is dead...
                        food.activate(curLevel);       //activate food, preparing to drop
                        }
                else if(food.active == 1){         //food is alive
                        //food hits bottom of screen.. just respawns at top
                        if((int)food.pos.y > APP_H-15){
                                food.die();
                                if(food.type != food.FOOD_TYPE_BOMB) FB.curStreak = 0; //reset fb's food streak when food hits bottom of screen
                                //food.activate();
                                }
                        //food hits fb's mouth.. start swallow sequence
                        else if((int)food.pos.y > APP_H-(int)FB.radius*2 && (int)food.pos.y < APP_H-(int)FB.radius && FB.active != 2){
                                if(food.pos.x >= FB.pos.x+FB.MOUTH_X1 && food.pos.x <= FB.pos.x+FB.MOUTH_X2){  //food is atop fb's open mouth
                                        FB.animActive = true;         //animation ready to begin
                                        food.swallow();               //start food swallow sequence
                                        }
                                }
                        }
                else if(food.active == 2){
                        food.pos.x = FB.pos.x+24.0f;           //cling food to fb's gulley
                        if(FB.animActive){                     //animation is active..
                                if(!FB.animReverse){
                                        if(FB.animCounter < FB.MAX_FB_MODE_ANIMS-1) FB.animCounter++;  //go forward through the animation frames
                                        else{
                                                FB.animReverse = true;  //start reversing animation
                                                if(soundOn) playClip(chomp_sound);     //play chomp sound effect
                                                }
                                        }
                                else{
                                        if(FB.animCounter > 0) FB.animCounter--;         //animate frames in reverse order
                                        else{
                                                FB.animReverse = FB.animActive = false;  //animation deactivates
                                                FB.animCounter = 0;                      //reset animation counter
                                                }
                                        }
                                }
                        if((int)food.pos.y > APP_H-20){
                                FB.score += food.points;       //add food points to fb's score
                                scoreTimer = 1;                //have score msg inflate a bit when points are added
                                if(FB.score >= (curLevel+1)*1000){
                                        curLevel++;            //if score reaches 1000x, goto next level
                                        levelTimer = 1;        //have "level" msg scale a bit as visual aid
                                        if(soundOn) playClip(levelup_sound);  //play level up chime
                                        }
                                if(FB.score < 0) FB.score = 0;                //set score to zero if it becomes negative
                                FB.animActive = FB.animReverse = false;       //animation deactivates
                                FB.animCounter = 0;                           //reset animation counter
                                food.die();                                   //kill this food
                                if(food.type == food.FOOD_TYPE_BOMB){
                                        if(soundOn) playClip(bomb_sound);
                                        FB.injure();                          //fb is injured by bomb
                                        }
                                else{
                                        FB.curStreak++;                       //eating successful, add to current food streak
                                        if(FB.curStreak > FB.bestStreak){
                                                FB.bestStreak = FB.curStreak; //update the record streak if necessary
                                                }
                                        }
                                FB.score += FB.curStreak*10;                  //give more points for longer streak
                                //food.activate();
                                }
                        }
                else if(food.active == 3){
                        }

                //fb is injured..
                if(FB.active == 2){
                        if(FB.animCounter < FB.INJURY_LENGTH) FB.animCounter++;  //hold onto the "ouch" animation for a bit..
                        else{
                                FB.animCounter = 0;       //reset animation counter
                                FB.active = 1;            //let FB eat some more..
                                }
                        }

                //game over..
                else if(FB.active == 3){
                        if(gameState != GAMESTATE_GAME_OVER){   //only do this stuff when game over sequence starts out
                                gameState = GAMESTATE_GAME_OVER;  //set to game over state
                                gameOver_pos.x = 160.0f-18.0f*5.0f; //set game over msg to center of window
                                gameOver_pos.y = FAPP_H/2.0f-10.0f;
                                gameOver_vel.x = ((float)Math.random()*10.0f)*5.0f;      //give random velocity
                                gameOver_vel.x = ((float)Math.random()*2.0f < 1.0f) ? gameOver_vel.x : -1.0f*gameOver_vel.x;  //give random negativity
                                gameOver_vel.y = ((float)Math.random()*10.0f)*5.0f;
                                gameOver_vel.y = ((float)Math.random()*2.0f < 1.0f) ? gameOver_vel.y : -1.0f*gameOver_vel.y;  //give random negativity

                                checkForHiScore();
                                doneTypingName = false;
                                }
                        else{
                                if(gotHiScore && doneTypingName){
                                        addNewScore();   //add the latest score
                                        sortScores();    //sort the score list

                                        String scoreFileString = "";
                                        for(int i = 0; i < numScores; i++){
                                                scoreFileString += gameHiScore[i].name;
                                                scoreFileString += "\n";
                                                scoreFileString += gameHiScore[i].score;
                                                scoreFileString += "\n";
                                                scoreFileString += gameHiScore[i].bestStreak;
                                                scoreFileString += "\n";
                                                scoreFileString += gameHiScore[i].level;
                                                scoreFileString += "\n";
                                                }
										if(isOnline){
                                        		System.out.println("Trying to send data.. " + "High score: " + FB.score + " Best streak: " + FB.bestStreak);
                                        		try{
                                                		//remoteWriter.sendData(playerName + "\n" + FB.score + "\n" + FB.bestStreak + "\n" + curLevel);
                                                		remoteWriter.sendData(scoreFileString);
                                                }catch(Exception e){
                                                        System.out.println("an exception has occured:" + e.getMessage());
                                                        }
												}
										else{
												String tempStr = "";
												PrintWriter out = null;
												System.out.println("Saving score data to file...");
												try{ out = new PrintWriter(HISCORE_FILENAME); } catch(Exception E){ System.out.println("Error creating PrintWriter."); }
														out.print(scoreFileString);
														out.close();
														}
                                        		gotHiScore = false;
                                        		}
                                if(gotHiScore && !doneTypingName){
                                        }
                                }
                        //saveScores("hiscore.txt");
                        }

                //more game over..
                if(gameState == GAMESTATE_GAME_OVER){
                        gameOver_pos.x += gameOver_vel.x*ft;   //bounce the game over msg around the screen
                        gameOver_pos.y += gameOver_vel.y*ft;
                        if(gameOver_pos.x < 0 || gameOver_pos.x > FAPP_W-125.0f){  //bounce when hitting left or right edgs
                                gameOver_vel.x *= -1.0f;
                                }
                        if(gameOver_pos.y < 16.0f || gameOver_pos.y > FAPP_H){ //bounce when hitting top or bottom edge
                                gameOver_vel.y *= -1.0f;
                                }
                        }

                //handle the various message timers..
                if(scoreTimer > 0 && scoreTimer < 4) scoreTimer++;
                else scoreTimer = 0;
                if(levelTimer > 0 && levelTimer < 10) levelTimer++;
                else levelTimer = 0;
                }

        //method for giving a string with a set number of "0" spaces (long)
        public String longNumberString(long number, int length)
        {
                String temp_str = new String();
                int power = 0;
                long temp_num = number;

                while(temp_num > 0){         //divide by 10 till number is 0
                        temp_num /= 10;
                        power++;             //count the powers of ten
                        }
                length -= power;
                while(length > 0){
                        temp_str += "0";     //start with # of 0's equal to power difference
                        length--;
                        }
                if(number != 0) temp_str += Long.toString(number);  //add original # to 0'ed string

                return temp_str;
        }

        //method for giving a string with a set number of "0" spaces (int)
        public String intNumberString(int number, int length)
        {
                String temp_str = new String();
                int power = 0, temp_num = number;

                while(temp_num > 0){         //divide by 10 till number is 0
                        temp_num /= 10;
                        power++;             //count the powers of ten
                        }
                length -= power;
                while(length > 0){
                        temp_str += "0";     //start with # of 0's equal to power difference
                        length--;
                        }
                if(number != 0) temp_str += Integer.toString(number);  //add original # to 0'ed string

                return temp_str;
        }

        //save scores to a file on the server
        public void saveScores(String filename)
        {
                String scoreFileString = "";
                for(int i = 0; i < numScores; i++){
                        scoreFileString += gameHiScore[i].name;
                        scoreFileString += "\n";
                        scoreFileString += gameHiScore[i].score;
                        scoreFileString += "\n";
                        scoreFileString += gameHiScore[i].bestStreak;
                        scoreFileString += "\n";
                        scoreFileString += gameHiScore[i].level;
                        scoreFileString += "\n";
                        }

				String tempStr = "";
				PrintWriter out = null;
				System.out.println("Saving score data to file...");
				try{ out = new PrintWriter(HISCORE_FILENAME); } catch(Exception E){ System.out.println("Error creating PrintWriter."); }
				out.print(scoreFileString);
				out.close();
        }

        //reload the hiscores from file
        public void reloadScores()
        {
//                numScores = 0;
                if(isOnline) loadRemoteScores();
				else loadScores(HISCORE_FILENAME);
        }

		//initialize a fresh scoreboard...
		public void initializeDummyScores(int sc)
		{
				int scoreStart = sc*(MAX_HISCORES);
				for(int i = 0; i < MAX_HISCORES; i++){
						gameHiScore[i] = new hiScore("", (long)(scoreStart-sc*i), (int)(Math.random()*5), (int)(Math.random()*10)+5);
						//numScores++;
						}
				gameHiScore[0].name = "Food Boy";
				gameHiScore[1].name = "Burger King";
				gameHiScore[2].name = "Greg";
				gameHiScore[3].name = "Alexander";
				gameHiScore[4].name = "Fruitmonger";
				gameHiScore[5].name = "Fast Philip";
				gameHiScore[6].name = "McDougal";
				gameHiScore[7].name = "Straw Barry";
				gameHiScore[8].name = "Daffy";
				gameHiScore[9].name = "Dizzy";
				gameHiScore[10].name = "Asimov";
				gameHiScore[11].name = "Buzz";
				gameHiScore[12].name = "Neil";
				gameHiScore[13].name = "Amadeus";
				gameHiScore[14].name = "Jay Ess";
				gameHiScore[15].name = "Nelson";
				gameHiScore[16].name = "Grimace";
				gameHiScore[17].name = "Dee Ray";
				gameHiScore[18].name = "Frank";
				gameHiScore[19].name = "Sammy";
		}

		//load the scores from the local storage
		public void loadScores(String filename)
		{
				int numDataVars = 4;
				//String[] tempStr = new String[MAX_SCORES*numDataVars];

				System.out.println("loading data from hiscore file " + filename + "...");
				//tempStr = tempStream.loadData(filename, MAX_SCORES*numDataVars);
				int count = 0;
				String[] tempStr2 = new String[MAX_HISCORES*numDataVars];
//				numScores = 0;
				boolean localFileExists = true;     //use this to see if we've got a hiscore.txt saved already
				String line = "";

				try
				{
					URL fileURL = null;
					BufferedReader bufferedReader = null;
					FileReader fileReader = null;

					// FileReader reads text files in the default encoding.
					try{ fileReader = new FileReader(filename); }
					catch(Exception E)   //if the file can't be read here, that means it doesn't exist yet locally..
					{
						localFileExists = false;
					}
					//FileReader fileReader = new FileReader(fileURL);

					if(localFileExists)
					{
						System.out.println("Hiscore file exists, so loading file for data extraction..");
						bufferedReader = new BufferedReader(fileReader);
						//bufferedReader = new BufferedReader(new InputStreamReader(getClass().getResourceAsStream(filename)));
					}
					else
					{
						System.out.println("Hiscore file doesn't exist, so setting initial hiscore board...");
						initializeDummyScores(500);
						saveScores(HISCORE_FILENAME);
						return;
					}

					tempStr2[0] = "NULL";

					if(tempStr2[0] == null) System.out.println("score 0 is null...");

					//keep going until there aren't any more words found in the string array
					while(count < MAX_HISCORES) // && tempStr2[count*numDataVars] != null)
					{
                        gameHiScore[count] = new hiScore();

                        line = bufferedReader.readLine();
						if(line == null) break;
						System.out.println("Count: " + count + " name: " + line);
                        gameHiScore[count].name = line;
                        line = bufferedReader.readLine();
						System.out.println("Count: " + count + " score: " + line);
                        gameHiScore[count].score = Integer.parseInt(line);
                        line = bufferedReader.readLine();
						System.out.println("Count: " + count + " level: " + line);
                        gameHiScore[count].bestStreak = Integer.parseInt(line);
                        line = bufferedReader.readLine();
						System.out.println("Count: " + count + " streak: " + line);
                        gameHiScore[count].level = Integer.parseInt(line);

						if(line == null) break;
							//System.out.println("Line #" + count*numDataVars+i + ": " + tempStr2[i]);
							//tempStr2[i] = tempStr[count*numDataVars+i];
							//System.out.println(tempStr2[i]);
						count++;
					}
					//}

					// Always close files.
					bufferedReader.close();
				}
				catch(FileNotFoundException ex)
				{
					System.out.println("Unable to open file '" + filename + "'");
					initializeDummyScores(500);
					saveScores(HISCORE_FILENAME);
				}
				catch(IOException ex)
				{
					System.out.println("Error reading file '" + filename + "'");
					initializeDummyScores(500);
					saveScores(HISCORE_FILENAME);
				}
		}

        //load scores from a file stored on the server
        public void loadRemoteScores()
        {
                URL url;
                try{
                        url = new URL("http","www.t3-i.com","/fbJava/hiscore.txt");
                        }catch(MalformedURLException e){ System.out.println("malformed URL.."); return; }
                URLConnection conn = null;
                DataInputStream data = null;
                String line;
                StringBuffer buf = new StringBuffer();

                try{
                        conn = url.openConnection();
                        conn.connect();

                        System.out.println("Connection opened...");

                        data = new DataInputStream(new BufferedInputStream(
                                conn.getInputStream()));
                        System.out.println("Reading data...");
                        int count = 0;
                        while ((line = data.readLine()) != null) {
                                gameHiScore[count] = new hiScore();
                                gameHiScore[count].name = line;
                                line = data.readLine();
                                gameHiScore[count].score = Integer.parseInt(line);
                                line = data.readLine();
                                gameHiScore[count].bestStreak = Integer.parseInt(line);
                                line = data.readLine();
                                gameHiScore[count].level = Integer.parseInt(line);
                                buf.append(line + "\n");
                                count++;
                                }

                        numScores = count;
                        System.out.println(buf.toString());
                        data.close();
                        }catch(IOException e){ System.out.println("IO Error:" + e.getMessage()); }
        }

        //draw the hiscore entry screen
        public void hiScoreEntryDisplay(Graphics g)
        {
                int x = 30, y = APP_H/2-42;
                int w = APP_W-x*2, h = 80;
                g.setColor(Color.black);
                g.drawRect(x, y, w, h);
                g.drawRect(x-1, y, w+1, h+1);
                g.setColor(new Color(0.0f, 87/255.0f, 179/255.0f));
                g.fillRect(x, y, w, h);
                g.setColor(Color.white);
                g.drawString("You got a high score!", APP_W/2-60, y+12);
                g.drawString("Enter your name: ", APP_W/2-40, y+27);
                g.fillRect(APP_W/2-(MAX_NAME_LENGTH/2)*gameFont.width-2, y+42, MAX_NAME_LENGTH*gameFont.width+2, 20);
                g.setColor(Color.black);
                g.drawRect(APP_W/2-(MAX_NAME_LENGTH/2)*gameFont.width-2, y+41, MAX_NAME_LENGTH*gameFont.width+2, 22);
                drawStringMyFont(g, playerName, APP_W/2-(MAX_NAME_LENGTH/2)*gameFont.width, y+44);
                g.setColor(new Color(99/255.0f, 116/255.0f, 1.0f));
                g.fillRect(APP_W/2-(MAX_NAME_LENGTH/2)*gameFont.width+playerName.length()*gameFont.width+1, y+46, gameFont.width-2, gameFont.height-2);
        }

        //reset the scoreboard before play..
        public void resetScoreBoardStuff()
        {
                scoreBoardPos.x = FAPP_W;
        }

        //scroll the scoreboard ticker
        public void moveScoreBoard()
        {
                scoreBoardPos.x -= 2.0f;
                //wrap back to the other edge when all names have been displayed
                if(scoreBoardPos.x < -(float)scoreBoardWidth) scoreBoardPos.x = FAPP_W;
        }

        //draw the hiscore list
        public void hiScoreDisplay(Graphics g, int x, int y, int w, int h)
        {
                moveScoreBoard();
                g.setColor(new Color(1.0f,1.0f,1.0f,0.4f));
                g.fillRect(x, y, w, h);
                g.setColor(new Color(0.0f, 0.0f, 0.0f, 0.625f));
                String str = "Highest Scores: ";
                for(int i = 0; i < numScores; i++){
                        str += "(" + (i+1) + ") " + gameHiScore[i].name + ": " + gameHiScore[i].score + "      ";
                        }
                scoreBoardWidth = str.length()*FONT_WIDTH;

                g.drawString(str, (int)scoreBoardPos.x, (int)scoreBoardPos.y);
        }

        //draw a string using my font.. (go figure!)
        public void drawStringMyFont(Graphics g, String str, int x, int y)
        {
                for(int i = 0; i < str.length(); i++){
                        g.drawImage(gameFont.pic[(int)str.charAt(i)], x+i*gameFont.width, y, gameFont.width, gameFont.height, this);
                        }
        }

        //check to see if we qualify for a hiscore
        public void checkForHiScore()
        {
                //reload the scores file first, in case someone else got a hiscore in the meantime
                reloadScores();

                //check to see if we beat any of the scores in the list..
                if(numScores >= MAX_HISCORES){
                        for(int i = 0; i < numScores; i++){
                                if(FB.score >= gameHiScore[i].score){
                                        gotHiScore = true;
                                        return;
                                        }
                                }
                        }
                else{   //automatically add score to list if there are still open spots
                        gotHiScore = true;
                        }
        }

        //add a new score to the score list
        public void addNewScore()
        {
                //make sure we don't go out of bounds here..
                if(numScores >= MAX_HISCORES) numScores--;

                gameHiScore[numScores] = new hiScore();
                gameHiScore[numScores].name = playerName;
                gameHiScore[numScores].score = FB.score;
                gameHiScore[numScores].bestStreak = FB.bestStreak;
                gameHiScore[numScores].level = curLevel;
                numScores++;
        }

        //sort the scores.. (use heap sort..)
        public void sortScores()
        {
                //no need to sort if < 2 scores in the list..
                if(numScores == 1 || numScores == 0) return;
                else if(numScores < 3){
                        if(gameHiScore[0].score < gameHiScore[1].score){
                                hiScore tempHi = gameHiScore[0];
                                gameHiScore[0] = gameHiScore[1];
                                gameHiScore[1] = tempHi;
                                }
                        }
                else{
                        for(int i = 1; i < numScores; i++){
                                hiScore tempHi = gameHiScore[i];
                                int j = i;
                                while(j > 0 && gameHiScore[j-1].score < tempHi.score){
                                        gameHiScore[j] = gameHiScore[j-1];
                                        j--;
                                        }
                                gameHiScore[j] = tempHi;
                                }
                        }
        }
		//start the application (graphics set-up, etc)
		public void beginApplication(Frame f, GraphicsDevice device)
		{
		      boolean isFullscreen;
		      isApplication = true;
		      if(!useFullscreen)
		      {
			         //f.setSize(APP_W, APP_H);
					    f.setSize(APP_W, APP_H+APP_WINDOWBAR_HEIGHT);
					    f.setVisible(true);
		      }
		      else
		      {
		           isFullscreen = device.isFullScreenSupported();
			       System.out.println("full screen support: " + isFullscreen);
        		   f.setUndecorated(isFullscreen);
        		   f.setResizable(!isFullscreen);
        		   if(isFullscreen)
				   {
            		 	// Full-screen mode
            			device.setFullScreenWindow(f);
		            	f.validate();
				   }
				   else
				   {
		        	  	// Windowed mode
		            	//f.pack();
					    f.setSize(APP_W, APP_H+APP_WINDOWBAR_HEIGHT);
					    //f.setSize(APP_W, APP_H-APP_WINDOWBAR_HEIGHT);
		            	f.setVisible(true);
		        	}
				}
			}

			//main loop (when used as application..)
			public static void main(String args[])
			{
				      final fbJava applet = new fbJava();
				      Frame f = new Frame(VERSION_STRING);
				      GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment();
				      GraphicsDevice device = env.getDefaultScreenDevice();

				      f.addWindowListener(new java.awt.event.WindowAdapter()
				      {
					         public void windowClosing(java.awt.event.WindowEvent e)
					         {
						             applet.stop();
						             applet.destroy();
						             System.exit(0);
					         };
				      });

				      f.add(applet, BorderLayout.CENTER);
				      applet.beginApplication(f, device);
				      f.show();
				      applet.init();    //initialize the applet
				      System.out.println("APP_W x APP_H = " + APP_W + " x " + APP_H); 
				      System.out.println("APP_W x APP_H + BAR_H = " + APP_W + " x " + APP_H + " + " + APP_WINDOWBAR_HEIGHT); 
				      applet.start();
			}
}
